local button = {}

local function draw (t)
	--This functions just draws the text in the screen
	--First we get the current state of things
	local f = love.graphics.getFont()
	local c = {love.graphics.getColor()}
	--Then we set the things we need, like the color and the font
	love.graphics.setColor(255, 255, 255, 255)
	love.graphics.setFont(t.font)
	--Then we print the text
	love.graphics.printf(t.link,t.x,t.y,t.l,t.t)
	--Then we leave everything as it was before
	love.graphics.setFont(f)
	love.graphics.setColor(c)
end

local function mousepressed (t,x,y,b)
	if b == "l" then --If the left click of the mouse was pressed
		if x >= t.x and x <= (t.x+t.w) and y >= t.y and y <= (t.y+t.h) then
			--We check if the button was pressed (that it was those "and" are for
			love.system.openURL(t.link) --Then we open the link
		end
	end
end

function button:new (x,y,link,l,t)
	--This is just a little bit of OOP magic... not really needed but allows us to create many different links
	local t = {
		x = x or 0,
		y = y or 0,
		link = link or "",
		l = l or math.huge,
		t = t or "left",
		font = love.graphics.newFont("assets/fonts/PirataOne-Regular.ttf")
	}
	
	t.w = l or t.font:getWidth(link)
	local _,L = t.font:getWrap(t.link,t.w)
	t.h = L * (t.font:getAscent() + t.font:getDescent()) * t.font:getLineHeight()
	function t:draw () draw(self) end
	function t:mousepressed(x,y,b) mousepressed(self,x,y,b) end
	
	return t
end

return button