require "player"
require "enemies"
require "maps"
require "menu"

function love.load()
	menu:load()
	player:load()
	enemies:load()
	maps:load()

	dev_mode = false
end

function love.update(dt)
	if menu.current_state == menu.states.menu then
		menu:update(dt)
	end
	if menu.current_state == menu.states.action then
		player:update(dt)
		enemies:update(dt)
	end
	maps:update(dt)
end

function love.draw()
	maps:draw()
	if menu.current_state == menu.states.menu then
		menu:draw()
	end

	if menu.current_state == menu.states.action then
		enemies:draw()
		player:draw()
	end
end

function love.keypressed(key)
	if key == "escape" then
		love.event.quit()
	end

	if key == "f1" and dev_mode == false then
		dev_mode = true
	elseif key == "f1" and dev_mode == true then
		dev_mode = false
	end

	player:key_pressed(key)
	player:restart(key)
	player:dash(key)

	if key == "m" then
		menu.current_state = menu.states.menu
	end

	if key == "o" then 
		music.main_menu:stop()
	end

	if key == "p" then 
		music.main_menu:play()
	end
end

function love.keyreleased(key)
	player:key_released(key)
end