maps = {}

function maps:load()
	self.background = love.graphics.newImage("assets/backgrounds/1.png")
	
	self.parallax_1 = {x = 0, y = 0, img = love.graphics.newImage("assets/backgrounds/2.png")}
	self.parallax_2 = {x = 0, y = 0, img = love.graphics.newImage("assets/backgrounds/2.png")}
	self.parallax_3 = {x = 0, y = -20, img = love.graphics.newImage("assets/backgrounds/3.png")}
	self.parallax_4 = {x = 0, y = -20, img = love.graphics.newImage("assets/backgrounds/3.png")}
	self.parallax_5 = {x = 0, y = 0, img = love.graphics.newImage("assets/backgrounds/4.png")}
	self.parallax_6 = {x = 0, y = 0, img = love.graphics.newImage("assets/backgrounds/4.png")}
	self.parallax_7 = {x = 0, y = 0, img = love.graphics.newImage("assets/maps/1.png")}
	self.parallax_8 = {x = 800, y = 0, img = love.graphics.newImage("assets/maps/1.png")}

	self.maps = {love.graphics.newImage("assets/maps/1.png")}

	self.map_no = 1
	self.current_map = self.maps[self.map_no]

	self.platform = {x = 380, y = 340, width = 40, height = 10}

	_platform = self.platform
end

function maps:update(dt)
	maps:parallax_u(self.parallax_1, self.parallax_2, 25, dt)
	maps:parallax_u(self.parallax_3, self.parallax_4, 50, dt)
	maps:parallax_u(self.parallax_5, self.parallax_6, 100, dt)
	maps:parallax_u(self.parallax_7, self.parallax_8, 300, dt)

	maps:platform_collision(dt)
end

function maps:draw()
	love.graphics.draw(self.background)
	maps:parallax_d(self.parallax_1, self.parallax_2)
	maps:parallax_d(self.parallax_3, self.parallax_4)
	maps:parallax_d(self.parallax_5, self.parallax_6)
	maps:parallax_d(self.parallax_7, self.parallax_8)

	maps:objects_d()
end

function maps:parallax_u(prlx1, prlx2, speed, dt)
	local width = prlx1.img:getWidth()

	if player.current_anim == player.animations.right_run or 
       player.current_anim == player.animations.right_roll or 
       player.current_anim == player.animations.right_dash or  
       player.current_anim == player.animations.right_slide or 
       menu.current_state == menu.states.menu then
		
		if prlx1.x + width <= 0 then
			prlx2.x = prlx1.x - speed * dt
			prlx1.x = prlx2.x + width
		end
	end

	if player.current_anim == player.animations.right_run or 
	   player.current_anim == player.animations.right_roll or 
       player.current_anim == player.animations.right_dash or  
       player.current_anim == player.animations.right_slide or 
       menu.current_state == menu.states.menu then
		
		if prlx1.x + width > 0 then
			prlx1.x = prlx1.x - speed * dt
			prlx2.x = prlx1.x + width
		end
	end
end

function maps:parallax_d(prlx1, prlx2)
	love.graphics.draw(prlx1.img, prlx1.x, prlx1.y)
	love.graphics.draw(prlx2.img, prlx2.x, prlx2.y)
end

function maps:objects_d()
	love.graphics.push()
	love.graphics.scale(2, 2)
	
	if dev_mode == true then
		love.graphics.rectangle("line", self.platform.x / 2, self.platform.y / 2, self.platform.width, self.platform.height)
	end
	
	love.graphics.pop() 
end

function maps:platform_collision(dt)		
	if player.current_anim == player.animations.right_run or 
       player.current_anim == player.animations.right_roll or 
   	   player.current_anim == player.animations.right_dash or  
       player.current_anim == player.animations.right_slide then
		
		_platform.x = _platform.x - 300 * dt
	end

	if (_platform.x + _platform.width) < 0 then
		_platform.x = screenWidth - _platform.width - 4
	end
	
	if player.y + player.height > (_platform.y - 80) and 
		player.x  + player.width > _platform.x and 
		player.x < _platform.x  + (_platform.width - 50) and 
		player.y < (_platform.y - 80) + _platform.height then

		player.jumping = false
		player.y = (_platform.y - 80) - player.height
	end
end